# Code Limit

Your Refactoring Alarm 🔔

<div align="center">

[![main](https://github.com/getcodelimit/codelimit/actions/workflows/main.yml/badge.svg)](https://github.com/getcodelimit/codelimit/actions/workflows/main.yml)
[![codecov](https://codecov.io/gh/getcodelimit/codelimit/branch/main/graph/badge.svg?token=ZQBEAJVC2Y)](https://codecov.io/gh/getcodelimit/codelimit)
[![Checked with mypy](https://www.mypy-lang.org/static/mypy_badge.svg)](https://mypy-lang.org/)
[![Code style: black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/psf/black)
[![Linting: Ruff](https://img.shields.io/endpoint?url=https://raw.githubusercontent.com/charliermarsh/ruff/main/assets/badge/v2.json)](https://github.com/astral-sh/ruff)
[![Checked with Code Limit](https://codelimit.vercel.app/api/badge/getcodelimit/codelimit)](https://github.com/getcodelimit/codelimit)

</div>

## Introduction

Code Limit is a tool for developers with one goal: _it tells the developer when
it’s time to refactor_.

Check out the [documentation](https://codelimit-docs.vercel.app) and start
using Code Limit today to keep your code maintainable.

## Quickstart

Depending on your development workflow, Code Limit can run in many different
ways (e.g.: pre-commit hook, GitHub Action, standalone, etc.). See the
[Quickstart documentation](https://codelimit-docs.vercel.app/quickstart/) for
examples.

## Standalone usage

Code Limit can run as a standalone program to check and inspect a codebase, see
the [Standalone Usage documentation](https://codelimit-docs.vercel.app/usage/)
to get started.

## Configuration

Code Limit aims to be zero-configuration. However, sometimes the exception
proves the rule. Check out the [Configuration
documentation](https://codelimit-docs.vercel.app/configuration/) for all
configuration options.

## Development

See the [Development
documentation](https://codelimit-docs.vercel.app/development) if you want to
extend or contribute to Code Limit.

## Feedback, suggestions and bug reports

If you have suggestions for how Code Limit could be improved, or want to report
a bug, [open an issue](https://github.com/getcodelimit/codelimit/issues)! All
and any contributions are appreciated.

To show your project uses Code Limit place this badge in the README markdown:

[![Checked with Code Limit](https://img.shields.io/badge/Code%20Limit-checked-green.svg)](https://github.com/getcodelimit/codelimit)

```
![Checked with Code Limit](https://img.shields.io/badge/Code%20Limit-checked-green.svg)](https://github.com/getcodelimit/codelimit)
```

## License

[GPL-3.0-or-later](LICENSE) © 2022 Rob van der Leek <robvanderleek@gmail.com>
(https://twitter.com/robvanderleek)
